"""Datatables and related components used in different contexts.
"""
import grok
from waeup.interfaces import (IUniversity, IFacultyContainer, IFaculty,
                              IDepartment)
from waeup.widgets.interfaces import ITableProvider
from waeup.widgets.table import YUITable as Table
from waeup.widgets.table import Col

class CodeAndTitleTableProvider(grok.Adapter):
    grok.baseclass()
    grok.provides(ITableProvider)

    title = None

    def getTable(self, view=None):
        data = self.context
        context_url = ''
        if view:
            context_url = view.url(self.context) + '/'
        cols = (
            Col(
                header='Code', sortable=True,
                data = tuple(['<a href="%s%s">%s</a>' % (
                            context_url, data[x].code,
                            data[x].code) for x in data])),
            Col(
                header='Title', sortable=True,
                data = tuple([data.getName(x) for x in data])),
            )
        self.table = Table(self.title, cols=cols)
        return self.table
    
class DepartmentTableProvider(CodeAndTitleTableProvider):
    grok.context(IFaculty)
    grok.provides(ITableProvider)
    title = 'Departments'

class FacultyTableProvider(CodeAndTitleTableProvider):
    grok.context(IFacultyContainer)
    grok.provides(ITableProvider)
    title = 'Faculties'
